> For the complete documentation index, see [llms.txt](https://docs.nexos.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nexos.ai/openai-sdks/python-sdk.md).

# Python SDK

### Chat Completion

```python
from openai import OpenAI
from openai.types.chat import ChatCompletionUserMessageParam, ChatCompletion

openai = OpenAI(
    api_key=api_key,
    base_url=api_url,
)
message: ChatCompletionUserMessageParam = {
    "role": "user",
    "content": "how many letters 'r' in the word 'strawberry'",
}
response: ChatCompletion = openai.chat.completions.create(model="gpt-3.5-turbo", messages=[message])
print(response.choices[0].message.content)
```

### Audio Generation

```python
from openai import OpenAI

openai = OpenAI(
    api_key=api_key,
    base_url=api_url,
)
response = openai.audio.speech.create(
    input="There are three letters 'r' in the word 'strawberry'.",
    model="tts-1",
    voice="alloy",
)
response.write_to_file("generated.mp3")
```

### Audio Transcription

```python
from openai import OpenAI

openai = OpenAI(api_key=api_key, base_url=api_url)
response = openai.audio.transcriptions.create(file=open('sound.mp3', 'rb'), model='whisper-1')
print(response.text)
```

### Audio Translation

```python
from openai import OpenAI

openai = OpenAI(api_key=api_key, base_url=api_url)
response = openai.audio.translations.create(file=open("sound.mp3", "rb"), model="whisper-1")
print(response.text)
```

### Image Generation

```python
from openai import OpenAI
from openai.types.images_response import ImagesResponse

openai = OpenAI(
    api_key=api_key,
    base_url=api_url,
)
response: ImagesResponse = openai.images.generate(
    prompt="three letters 'r' with strawberry texture",
    model="dall-e-3",
)
if response.data is not None:
    print(response.data[0].url)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nexos.ai/openai-sdks/python-sdk.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
